/*
 *  Copyright (C) 2009 Ludovic Jacomme (ludovic.jacomme@gmail.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <zlib.h>
#include "SDL.h"



#include <stdlib.h>
#include <stdio.h>
#include <string.h>


#include "jxd_ctrl.h"
#include "jxd_global.h"
#include "jxd_menu.h"
#include "jxd_sdl.h"

  MANCALA_t MANCALA;

int
jxd_global_reset()
{
  int Index;

  MANCALA.current_x[MANCALA_NORTH] = 0;
  MANCALA.current_x[MANCALA_SOUTH] = 0;
  MANCALA.score[MANCALA_NORTH] = 0;
  MANCALA.score[MANCALA_SOUTH] = 0;

  MANCALA.mancala_game_over = 0;
  MANCALA.computer_player = MANCALA_NORTH;
  MANCALA.to_move = MANCALA_SOUTH;
 
  for (Index = 0; Index < MANCALA_NUM_PITS; Index++) {
    MANCALA.board_array[Index] = MANCALA.mancala_init_stones;
  }

  return 0;
}

int
jxd_global_init()
{
  memset(&MANCALA, 0, sizeof(MANCALA_t));

  MANCALA.xor_color     = jxd_sdl_rgb(0xff, 0xff, 0xff);
  MANCALA.board_color    = 0x0;

  MANCALA.mancala_game_mode   = MANCALA_HUMAN_VS_COMPUTER;
  MANCALA.mancala_game_rules  = MANCALA_AWARI;
  MANCALA.mancala_level       = 1;

  MANCALA.mancala_init_stones = MANCALA_INIT_STONES;

  jxd_parse_configuration();

  jxd_global_reset();

  return 0;
}

int
jxd_save_configuration(void)
{
  char  FileName[MAX_PATH];
  FILE* FileDesc;
  int   error = 0;

  strcpy(FileName, "./mancala.cfg");

  FileDesc = fopen(FileName, "w");
  if (FileDesc != (FILE *)0 ) {

    fprintf(FileDesc, "mancala_game_mode=%d\n", MANCALA.mancala_game_mode);
    fprintf(FileDesc, "mancala_game_rules=%d\n", MANCALA.mancala_game_rules);
    fprintf(FileDesc, "mancala_level=%d\n", MANCALA.mancala_level);
    fprintf(FileDesc, "mancala_init_stones=%d\n", MANCALA.mancala_init_stones);

    fclose(FileDesc);

  } else {
    error = 1;
  }

  return error;
}

int
jxd_parse_configuration(void)
{
  char  FileName[MAX_PATH + 1];
  char  Buffer[512];
  char *Scan;
  unsigned int Value;
  FILE* FileDesc;

  strcpy(FileName, "./mancala.cfg");

  FileDesc = fopen(FileName, "r");
  if (FileDesc == (FILE *)0 ) return 0;

  while (fgets(Buffer,512, FileDesc) != (char *)0) {

    Scan = strchr(Buffer,'\n');
    if (Scan) *Scan = '\0';
    /* For this #@$% of windows ! */
    Scan = strchr(Buffer,'\r');
    if (Scan) *Scan = '\0';
    if (Buffer[0] == '#') continue;

    Scan = strchr(Buffer,'=');
    if (! Scan) continue;

    *Scan = '\0';
    Value = atoi(Scan+1);

    if (!strcasecmp(Buffer,"mancala_game_mode")) MANCALA.mancala_game_mode = Value;
    else
    if (!strcasecmp(Buffer,"mancala_game_rules")) MANCALA.mancala_game_rules = Value;
    else
    if (!strcasecmp(Buffer,"mancala_level")) MANCALA.mancala_level = Value;
    else
    if (!strcasecmp(Buffer,"mancala_init_stones")) MANCALA.mancala_init_stones = Value;
  }

  fclose(FileDesc);

  return 0;
}


