/*
 *  Copyright (C) 2007 Ludovic Jacomme (ludovic.jacomme@gmail.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

# ifndef _JXD_MENU_H_
# define _JXD_MENU_H_

# define JXD_MENU_BORDER_COLOR     jxd_sdl_rgb(0x80,0x80,0xF0)
# define JXD_MENU_WARNING_COLOR    jxd_sdl_rgb(0xFF,0x00,0x00)
# define JXD_MENU_NOTE_COLOR       jxd_sdl_rgb(0xFF,0xFF,0x00)
# define JXD_MENU_BACKGROUND_COLOR jxd_sdl_rgb(0x00,0x00,0x00)
# define JXD_MENU_BLACK_COLOR      jxd_sdl_rgb(0x00,0x00,0x00)
# define JXD_MENU_NORTH_COLOR      jxd_sdl_rgb(0xFF,0xFF,0xFF)
# define JXD_MENU_SOUTH_COLOR      jxd_sdl_rgb(0x00,0xF0,0xF0)
# define JXD_MENU_AUTHOR_COLOR     jxd_sdl_rgb(0x00,0x00,0xFF)
# define JXD_MENU_BLUE_COLOR       jxd_sdl_rgb(0x00,0x00,0xFF)
# define JXD_MENU_GREEN_COLOR      jxd_sdl_rgb(0x00,0xFF,0x00)
# define JXD_MENU_RED_COLOR        jxd_sdl_rgb(0xFF,0x00,0x00)
# define JXD_MENU_YELLOW_COLOR     jxd_sdl_rgb(0xFF,0xFF,0x00)

//# define JXD_MENU_TEXT_COLOR       jxd_sdl_rgb(0x80,0x80,0x80)
# define JXD_MENU_TEXT_COLOR       jxd_sdl_rgb(0xc0,0xc0,0xc0)
# define JXD_MENU_TEXT2_COLOR      jxd_sdl_rgb(0xff,0xff,0xff)
# define JXD_MENU_SEL_COLOR        jxd_sdl_rgb(0x00,0xff,0xff)
# define JXD_MENU_SEL2_COLOR       jxd_sdl_rgb(0xFF,0x00,0x80)
# define JXD_MENU_HELP_COLOR       jxd_sdl_rgb(0x00,0xff,0xff)
# define JXD_MENU_WHITE_COLOR      jxd_sdl_rgb(0xFF,0xFF,0xFF)

# define JXD_MENU_MIN_TIME         150000

  typedef struct menu_item_t {
    char *title;
    int   x0, y0, x1, y1;
  } menu_item_t;

# if defined(MOUSE_MODE)
  extern void jxd_menu_set_mouse_area( menu_item_t* menu_item, int x, int y, int y_step );
  extern int jxd_menu_is_mouse_area( menu_item_t* menu_item, jxdCtrlData* c );
# endif

   extern int jxd_main_menu(void);
  extern void string_fill_with_space(char *buffer, int size);

# endif
