/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

# ifndef _JXD_SDL_H_
# define _JXD_SDL_H_

#ifdef __cplusplus
extern "C" {
#endif


# define JXD_SDL_NOP   0
# define JXD_SDL_XOR   1

# define JXD_LINE_SIZE           800
# define JXD_SDL_SCREEN_WIDTH    800
# define JXD_SDL_SCREEN_HEIGHT   480

  typedef unsigned char   uchar;
#if defined( LINUX_MODE )
  typedef unsigned int    uint;
# endif
#if defined( LINUX_MODE ) || defined( ANDROID_MODE )
  typedef unsigned short  ushort;
# endif

  extern int jxd_sdl_get_ttf_width(void);
  extern int jxd_sdl_get_ttf_height(void);
  extern int jxd_sdl_get_btm_width(void);
  extern int jxd_sdl_get_btm_height(void);
  extern int jxd_print_text(char * str, int colour, int v, int h);

  extern void loc_jxd_debug(char *file, int line, char *message);

  /* PG -> SDL function */

  extern int  jxd_sdl_print_ttf(int x,int y,const char *str, int color);
  extern void jxd_sdl_print_btm(int x,int y, const char *str, int color);
  extern void jxd_sdl_fill_print_btm(int x,int y,const char *str, int color, int bgcolor);

  extern void jxd_sdl_clear_screen(int color);
  extern void jxd_sdl_fill_rectangle(int x, int y, int w, int h, int color, int mode);
  extern void jxd_sdl_draw_rectangle(int x, int y, int w, int h, int border, int mode);
  extern void jxd_sdl_flip(void);

  extern int  jxd_sdl_init(void);
  extern void jxd_sdl_blit_background();
  extern void jxd_sdl_blit_board();
  extern void jxd_sdl_blit_piece_xy(int x, int y, int is_black, int piece);
  extern void jxd_sdl_exit(int status);
  extern uint jxd_sdl_rgb(uchar R, uchar G, uchar B);
  extern ushort * jxd_sdl_get_vram_addr(uint x, uint y);

# endif
